/**************                SQUARE GRID                   ******************/
/********      DEPTH   /   BREADTH   FIRST EXPLORATION   *********/

#include <SDL/SDL.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#define L 33
#define YES 1
#define NO 0
#define step  18
#define NS (L*L)
#define RR step/4
#define rr step/8
void pause(void);
void putpixel(int xe, int ye, Uint32 couleur);
Uint32 getpixel(int xe, int ye);
void filldisc( int xo, int yo, int R, Uint32 couleur);
void line(int x0,int y0, int x1,int y1, Uint32 c);
void linewithwidth(int x1, int y1, int x2, int y2, int width,Uint32 c);
void visit (int i);
int nbv[NS],v[NS][4],xorig,yorig,x[NS],y[NS],done[NS],start,lengthqueue,queue[NS];
SDL_Surface * screen; Uint32 white,red,blue;

int main(int argc, char ** argv)
{   int i,j,k,neighbour;
    SDL_Init(SDL_INIT_VIDEO);
    screen=SDL_SetVideoMode(800,600,32, SDL_HWSURFACE|SDL_DOUBLEBUF);
    white=SDL_MapRGB(screen->format,255,255,255);
    red=SDL_MapRGB(screen->format,255,0,0);
    blue=SDL_MapRGB(screen->format,0,0,255);
    SDL_FillRect(screen,0,white);
/** square grid with vertices and their neighbours */
    xorig=10; yorig=10;
    for(i=0;i<NS;i++)  {x[i]=xorig+step*(i%L); y[i]=yorig+step*(i/L);}
    for(i=0;i<NS;i++)  filldisc(x[i],y[i],2,blue);
    for(i=0;i<NS;i++)
     { k=0;
       if (i>=L) v[i][k++]=i-L;
       if (i%L!=0) v[i][k++]=i-1;
       if ((i+1)%L!=0) v[i][k++]=i+1;
       if (i<L*L-L) v[i][k++]=i+L;
       nbv[i]=k;
     }
  for(i=0;i<NS;i++)  for(k=0;k<nbv[i];k++)  line(x[i],y[i],x[v[i][k]],y[v[i][k]],blue);
  SDL_Flip(screen);pause();

  /** depth fitst search */
  start=NS/2; filldisc(x[start],y[start],3,red);
  visit(start);
  SDL_Flip(screen);pause();SDL_FillRect(screen,0,white);

/** width first search */
  filldisc(x[start],y[start],3,red);
  for(i=0;i<NS;i++)  for(k=0;k<nbv[i];k++)  line(x[i],y[i],x[v[i][k]],y[v[i][k]],blue);
  for(i=0;i<NS;i++)  done[i]=0;
  queue[0]=start; lengthqueue=1;
  while (lengthqueue!=0)
    { i=queue[0];
       for(j=0;j<nbv[i];j++)
         { neighbour=v[i][j];
            if  (done[neighbour]==0)
              {
                done[neighbour]=1;
                queue[lengthqueue]=neighbour; lengthqueue++;
                linewithwidth(x[i],y[i],x[neighbour],y[neighbour],1,red);
              }
         }
     for(j=0;j<lengthqueue-1;j++)    queue[j]=queue[j+1];
     lengthqueue-- ;
     SDL_Flip(screen);
    }
SDL_Flip(screen);pause(); return 0;
}

void visit(int i)
{ int j,neighbour;
  done[i]=1;
  for(j=0;j<nbv[i];j++)
    { neighbour=v[i][j];
       if (done[neighbour]==0)
         { linewithwidth(x[i],y[i],x[neighbour],y[neighbour],1,red); SDL_Flip(screen);
            visit(neighbour);
         }
    }
}

void pause(void)
{
    SDL_Event evenement;
    do   SDL_WaitEvent(&evenement);
    while(evenement.type != SDL_QUIT && evenement.type != SDL_KEYDOWN);
}

void putpixel(int xe, int ye, Uint32 couleur)
{ Uint32 * numerocase;
numerocase= (Uint32 *)(screen->pixels)+xe+ye*screen->w;    *numerocase=couleur;
}

Uint32 getpixel(int xe, int ye)
{ Uint32 * numerocase;
   numerocase= (Uint32 *)(screen->pixels)+xe+ye*screen->w;   return (*numerocase);
}

  void filldisc( int xo, int yo, int R, Uint32 couleur)
  {
      int x, y, F, F1, F2,newx,newy,xx;
      x=xo; y=yo+R; F=0;
      if (x<800 && x>=0 && y>=0 && y<600) putpixel(x,y,couleur);
      if (x<800 && x>=0 && 2*yo-y>=0 && 2*yo-y<600) putpixel (x,2*yo-y, couleur);
      while( y>yo)
         {
             F1=F+2*(x-xo)+1; F2=F-2*(y-yo)+1;
             if ( abs(F1)<abs(F2))  { x+=1; F=F1;}
             else {y-=1; F=F2;}
             newx=2*xo-x ; newy=2*yo-y ;
             for(xx=newx; xx<=x; xx++)if (xx<800 && xx>=0 && y>=0 && y<600 )
             putpixel(xx,y,couleur);
             for(xx=newx; xx<=x; xx++)if (xx<800 && xx>=0 && newy>=0 && newy<600 )
             putpixel(xx,newy,couleur);
         }
       if (xo+R<800 && xo+R>=0&& y>=0 && y<600) putpixel(xo+R,yo,couleur);
       if (xo-R<800 && xo-R>=0&& y>=0 && y<600) putpixel(xo-R,yo, couleur);
  }

void line(int x0,int y0, int x1,int y1, Uint32 c)
{
int dx,dy,x,y,residu,absdx,absdy,stepx,stepy,i;
dx=x1-x0; dy=y1-y0;  residu=0;       x=x0;y=y0;  putpixel(x,y,c);
if (dx>0) stepx=1;else stepx=-1; if (dy>0) stepy=1; else stepy=-1;
absdx=abs(dx);absdy=abs(dy);
if (dx==0) for(i=0;i<absdy;i++) { y+=stepy;
                                                    putpixel(x,y,c); }
else if(dy==0) for(i=0;i<absdx;i++){ x+=stepx;
                                                         putpixel(x,y,c);  }
else if (absdx==absdy)
   for(i=0;i<absdx;i++) {x+=stepx; y+=stepy;
                                     putpixel(x,y,c);
                                     }
else if (absdx>absdy)
          for(i=0;i<absdx;i++)
			  { x+=stepx; residu+=absdy;
			     if(residu >= absdx) {residu -=absdx; y+=stepy;}
			     putpixel(x,y,c);
			  }
else for(i=0;i<absdy;i++)
             {y+=stepy; residu +=absdx;
              if (residu>=absdy)   {residu -= absdy;x +=stepx;}
              putpixel(x,y,c);
             }
}

void linewithwidth(int x1, int y1, int x2, int y2, int width,Uint32 c)
{
int dx,dy;
float k,xf1,yf1,xf2,yf2,d,dx1,dy1,ndx1,ndy1,ndx2,ndy2,angle=M_PI/2.;
line(x1,y1,x2,y2,c);
dx=x2-x1; dy=y2-y1;       d=sqrt(dx*dx+dy*dy);
if (d!=0.)      /* si le vecteur n’est step nul */
{ dx1=(float)width*(float)dx/d; dy1=(float)width*(float)dy/d;
   ndx1=dx1*cos(angle)-dy1*sin(angle);
   ndy1=dx1*sin(angle)+dy1*cos(angle);
   ndx2=dx1*cos(-angle)-dy1*sin(-angle);
   ndy2=dx1*sin(-angle)+dy1*cos(-angle);
   for(k=0;k<=1.;k+=0.1/d)
   {
   xf1=(1.-k)*x1+k*x2; yf1=(1.-k)*y1+k*y2;
   xf2=xf1-ndx1; yf2=yf1-ndy1;  line(xf1,yf1,xf2,yf2,c);
   xf2=xf1-ndx2; yf2=yf1-ndy2;    line(xf1,yf1,xf2,yf2,c);
   }
}
}


