/*****************         TRANSITIVE CLOSURE        ******************/
/*****************          Fig. 30-25                                 ******************/
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include  <time.h>
#define NV 8
void drawing(void);
void matrix(void);
void explore(int s);
void closuredrawing(void);
void pause(void);
void putpixel(int xe, int ye, Uint32 couleur);
Uint32 getpixel(int xe, int ye);
void circle( int xo, int yo, int R, Uint32 couleur);
void filldisc(int xo, int yo, int R,Uint32 couleur);
void line(int x0,int y0, int x1,int y1, Uint32 c);
void arrow(int x1, int y1, int x2, int y2, Uint32 c);
void linewithwidth(int x1, int y1, int x2, int y2, int epaisseur,Uint32 c);
SDL_Surface * screen; Uint32 white,color[9];  SDL_Color cblack={0,0,0};
SDL_Surface *texte;  SDL_Rect position;TTF_Font *police=NULL;char chiffre[2000];
int x[NV],y[NV],s[NV][NV],ss[NV][NV],fait[NV],xorig,yorig,step,icolor;

int main(int argc, char ** argv)
{  int i,j,k,h;
   SDL_Init(SDL_INIT_VIDEO);
   screen=SDL_SetVideoMode(800,600,32, SDL_HWSURFACE|SDL_DOUBLEBUF);
   white=SDL_MapRGB(screen->format,255,255,255);
   color[0]=SDL_MapRGB(screen->format,0,0,0);
   color[1]=SDL_MapRGB(screen->format,255,0,0);
   color[4]=SDL_MapRGB(screen->format,150,50,150);
   color[2]=SDL_MapRGB(screen->format,0,250,0);
   color[5]=SDL_MapRGB(screen->format,150,200,150);
   color[3]=SDL_MapRGB(screen->format,0,0,250);
   color[6]=SDL_MapRGB(screen->format,150,150,200);
   color[7]=SDL_MapRGB(screen->format,255,255,0);
   color[8]=SDL_MapRGB(screen->format,200,200,200);
   SDL_FillRect(screen,0,white);
   TTF_Init();  police=TTF_OpenFont("times.ttf",20);
   srand(time(NULL));

  /** adjacency matrix */
for(i=0;i<NV;i++) for(j=0;j<NV;j++) s[i][j]=0;
for(i=0;i<NV;i+=2)  { h=rand()%2; if (h==0) s[i][i+1]=1;  else   s[i+1][i]=1; }
for(i=0;i<NV-4;i++) {h=rand()%2;if (h==0) s[i][i+4]=1; else s[i+4][i]=1;}
for(i=0;i<NV;i++) s[i][i]=1;
s[1][2]=1;   s[NV-2][NV-3]=1;
step=70;xorig=30; yorig=30; for(i=0;i<NV;i++) {x[i]=step*(i%4);y[i]=step*(i/4);}
drawing();
SDL_Flip(screen); pause();

for(i=0;i<NV;i++) for(j=0;j<NV;j++) ss[i][j]=s[i][j];
matrix();
SDL_Flip(screen); pause();

yorig=200; xorig=30;step=70; icolor=3;
for(k=0;k<NV;k++)
{
for(i=0;i<NV;i++) {x[i]=step*(i%4);y[i]=step*(i/4);}

sprintf( chiffre,"%d",k);
           texte=TTF_RenderText_Solid(police,chiffre,cblack);
           position.x=xorig; position.y=yorig-20;
           SDL_BlitSurface(texte,NULL,screen,&position);

for(i=0;i<NV;i++) for(j=0;j<NV;j++)
if (ss[i][j]==0 && ss[i][k]==1 && ss[k][j]==1) ss[i][j]=1;
if (k==NV-1) {icolor=1;}
closuredrawing();
xorig+=250;if (xorig>550) { yorig+=110;xorig=30;};
}
xorig-=250; matrix();

SDL_Flip(screen); pause();  TTF_CloseFont(police); TTF_Quit();  return 0;
}

void matrix(void)
{ int i,j;
   police=TTF_OpenFont("times.ttf",18);
   for(i=0; i<NV; i++) for(j=0; j<NV; j++)
     {  sprintf( chiffre,"%d",ss[i][j]);
         texte=TTF_RenderText_Solid(police,chiffre,cblack);
         position.x=xorig+300+20*j; position.y=yorig-10+20*i;
         SDL_BlitSurface(texte,NULL,screen,&position);
     }
}

void explore(int v)
{
int j;
fait[v]=1;
for(j=0;j<NV;j++) if (s[v][j]==1 && fait[j]==0)
  {
  filldisc(xorig+x[v],yorig+y[v],4,color[1]);  filldisc(xorig+x[j],yorig+y[j],4,color[1]);
  linewithwidth(xorig+x[v],yorig+y[v],xorig+x[j],yorig+y[j],1,color[1]);
  explore(j);
  }
}

void drawing(void)
{  int i,j;
   for(i=0;i<NV;i++)
         {
		   filldisc(xorig+x[i],yorig+y[i],2,color[0]);
		   sprintf( chiffre,"%d",i);
           texte=TTF_RenderText_Solid(police,chiffre,cblack);
           position.x=xorig+x[i]+10; position.y=yorig+y[i]-2;
           SDL_BlitSurface(texte,NULL,screen,&position);
		  }
  for(i=0;i<NV;i++) for(j=0;j<NV;j++) if (s[i][j]==1 && i!=j)
    { arrow(xorig+x[i],yorig+y[i],xorig+x[j],yorig+y[j],color[1]);  }
}


void closuredrawing(void)
{  int i,j;
  for(i=0;i<NV;i++) for(j=0;j<NV;j++) if (ss[i][j]==1 && i!=j)
    { arrow(xorig+x[i],yorig+y[i],xorig+x[j],yorig+y[j],color[icolor]); }
}

void pause(void)
{
    SDL_Event evenement;
    do   SDL_WaitEvent(&evenement);
    while(evenement.type != SDL_QUIT && evenement.type != SDL_KEYDOWN);
}

void putpixel(int xe, int ye, Uint32 couleur)
{ Uint32 * numerocase;
numerocase= (Uint32 *)(screen->pixels)+xe+ye*screen->w;    *numerocase=couleur;
}

Uint32 getpixel(int xe, int ye)
{ Uint32 * numerocase;
   numerocase= (Uint32 *)(screen->pixels)+xe+ye*screen->w;   return (*numerocase);
}

void linewithwidth(int x1, int y1, int x2, int y2, int epaisseur,Uint32 c)
{
int dx,dy;
float k,xf1,yf1,xf2,yf2,d,dx1,dy1,ndx1,ndy1,ndx2,ndy2,angle=M_PI/2.;
line(x1,y1,x2,y2,c);
dx=x2-x1; dy=y2-y1;       d=sqrt(dx*dx+dy*dy);
if (d!=0.)      /* si le vecteur n’est step nul */
{ dx1=(float)epaisseur*(float)dx/d; dy1=(float)epaisseur*(float)dy/d;
   ndx1=dx1*cos(angle)-dy1*sin(angle);
   ndy1=dx1*sin(angle)+dy1*cos(angle);
   ndx2=dx1*cos(-angle)-dy1*sin(-angle);
   ndy2=dx1*sin(-angle)+dy1*cos(-angle);
   for(k=0;k<=1.;k+=0.1/d)
   {
   xf1=(1.-k)*x1+k*x2; yf1=(1.-k)*y1+k*y2;
   xf2=xf1-ndx1; yf2=yf1-ndy1;  line(xf1,yf1,xf2,yf2,c);
   xf2=xf1-ndx2; yf2=yf1-ndy2;    line(xf1,yf1,xf2,yf2,c);
   }
}
}

void circle( int xo, int yo, int R, Uint32 couleur)
  {
      int x, y, F, F1, F2,newx,newy;
      x=xo; y=yo+R; F=0;
      if (x<800 && x>=0 && y>=0 && y<600) putpixel(x,y,couleur);
      if (x<800 && x>=0 && 2*yo-y>=0 && 2*yo-y<600) putpixel (x,2*yo-y, couleur);
      while( y>yo)
         {
             F1=F+2*(x-xo)+1; F2=F-2*(y-yo)+1;
             if ( abs(F1)<abs(F2))  { x+=1; F=F1;}
             else {y-=1; F=F2;}
             if (x<800 && x>=0 && y>=0 && y<600) putpixel(x,y,couleur);
              newx=2*xo-x ; newy=2*yo-y ;
             if (x<800 && x>=0 && newy>=0 && newy<600) putpixel(x, newy,couleur);
             if (newx<800 && newx>=0 && y>=0 && y<600) putpixel( newx,y,couleur);
             if (newx<800 && newx>=0 && newy>=0 && newy<600) putpixel(newx,
             newy, couleur);
         }
       if (xo+R<800 && xo+R>=0 && yo>=0 && yo<600) putpixel(xo+R,yo,couleur);
       if (xo-R<800 && xo-R>=0 && yo>=0 && yo<600) putpixel(xo-R,yo, couleur);
  }

void filldisc( int xo, int yo, int R, Uint32 couleur)
  {
      int x, y, F, F1, F2,newx,newy,xx;
      x=xo; y=yo+R; F=0;
      if (x<800 && x>=0 && y>=0 && y<600) putpixel(x,y,couleur);
      if (x<800 && x>=0 && 2*yo-y>=0 && 2*yo-y<600) putpixel (x,2*yo-y, couleur);
      while( y>yo)
         {
             F1=F+2*(x-xo)+1; F2=F-2*(y-yo)+1;
             if ( abs(F1)<abs(F2))  { x+=1; F=F1;}
             else {y-=1; F=F2;}
             newx=2*xo-x ; newy=2*yo-y ;
             for(xx=newx; xx<=x; xx++)if (xx<800 && xx>=0 && y>=0 && y<600 )
             putpixel(xx,y,couleur);
             for(xx=newx; xx<=x; xx++)if (xx<800 && xx>=0 && newy>=0 && newy<600 )
             putpixel(xx,newy,couleur);
         }
       if (xo+R<800 && xo+R>=0&& y>=0 && y<600) putpixel(xo+R,yo,couleur);
       if (xo-R<800 && xo-R>=0&& y>=0 && y<600) putpixel(xo-R,yo, couleur);
  }
/**  stair line */
void line(int x0,int y0, int x1,int y1, Uint32 c)
{
int dx,dy,x,y,residu,absdx,absdy,pasx,pasy,i;
dx=x1-x0; dy=y1-y0;  residu=0;       x=x0;y=y0;  if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
if (dx>0) pasx=1;else pasx=-1; if (dy>0) pasy=1; else pasy=-1;
absdx=abs(dx);absdy=abs(dy);
if (dx==0) for(i=0;i<absdy;i++) { y+=pasy;
                                                    if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c); }
else if(dy==0) for(i=0;i<absdx;i++){ x+=pasx;
                                                         if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);  }
else if (absdx==absdy)
   for(i=0;i<absdx;i++) {x+=pasx; if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
                                     y+=pasy;
                                     if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
                                     }
else if (absdx>absdy)
          for(i=0;i<absdx;i++)
			  { x+=pasx; if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
			     residu+=absdy;
			     if(residu >= absdx) {residu -=absdx; y+=pasy;
	                              		        if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
			                                    }
			  }
else for(i=0;i<absdy;i++)
             {y+=pasy; if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
               residu +=absdx;
              if (residu>=absdy)   {residu -= absdy;x +=pasx;
                                              if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
                                             }
             }
}

void arrow(int x1, int y1, int x2, int y2, Uint32 c)
{
int dx,dy;
float xf1,yf1,xf2,yf2,d,dx1,dy1,ndx1,ndy1,ndx2,ndy2,angle=M_PI/6.;
line(x1,y1,x2,y2,c);
dx=x2-x1; dy=y2-y1;       d=sqrt(dx*dx+dy*dy);
if (d!=0.)
{ dx1=10.*(float)dx/d; dy1=10.*(float)dy/d;
   ndx1=dx1*cos(angle)-dy1*sin(angle);
   ndy1=dx1*sin(angle)+dy1*cos(angle);
   xf1=0.5*x1+0.5*x2; yf1=0.5*y1+0.5*y2;     xf2=xf1-ndx1; yf2=yf1-ndy1;
   line(xf1,yf1,xf2,yf2,c);
   ndx2=dx1*cos(-angle)-dy1*sin(-angle);
   ndy2=dx1*sin(-angle)+dy1*cos(-angle);
   xf2=xf1-ndx2; yf2=yf1-ndy2;    line(xf1,yf1,xf2,yf2,c);
}
}




